
<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('商品编码')" prop="productCode">
        <el-input v-model="queryParams.productCode" :placeholder="$t('请输入商品编码')" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item :label="$t('海关编码')" prop="customsCode">
        <el-input v-model="queryParams.customsCode" :placeholder="$t('请输入海关编码')" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item :label="$t('商品名称')" prop="titleZh">
        <el-input v-model="queryParams.titleZh" :placeholder="$t('请输入商品名称')" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item :label="$t('商品类型')" prop="attrId">
        <el-select v-model="queryParams.typeId" :placeholder="$t('选择商品类型')" clearable>
          <el-option v-for="types in typeList" :key="types.id" :label="$l(types, 'title')" :value="types.id" />
        </el-select>
      </el-form-item>

      <el-form-item :label="$t('商品特性')" prop="attrId">
        <el-select v-model="queryParams.attrId" :placeholder="$t('选择商品特性')" clearable>
          <el-option v-for="attr in attrList" :key="attr.id" :label="attr.attrName" :value="attr.id" />
        </el-select>
      </el-form-item>

      <!-- <el-form-item :label="$t('审核状态')" prop="auditStatus">
        <el-select v-model="queryParams.auditStatus" :placeholder="$t('选择审核状态')" clearable>
          <el-option v-for="auditStatusItem in auditStatusDictDatas" :key="auditStatusItem.id" :label="auditStatusItem.label" :value="auditStatusItem.value" />
        </el-select>
      </el-form-item>

      <el-form-item :label="$t('上架状态')" prop="status">
        <el-select v-model="queryParams.status" :placeholder="$t('选择上架状态')" clearable>
          <el-option v-for="statusItem in statusDictDatas" :key="statusItem.id" :label="statusItem.value == CommonStatusEnum.ENABLE ? '已上架' : '已下架'" :value="statusItem.value" />
        </el-select>
      </el-form-item> -->

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form>


    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column :label="$t('序号')" align="center" prop="id" />
      <el-table-column :label="$t('商品类型')" align="center" prop="typeId">
        <template slot-scope="scope">
          <span>{{ getTypeName(scope.row.typeId) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('中文标题')" align="center" prop="titleZh" />
      <el-table-column :label="$t('英文标题')" align="center" prop="titleEn" />
      <el-table-column prop="airWeightLimit" :label="$t('订单重量上限kg')"></el-table-column>

      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button @click="copyLine(scope.row , false)"  type="text">仅复制商品</el-button>
          <el-button @click="copyLine(scope.row , true)" type="text">复制商品与路线价格</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize" @pagination="getList" />

  </div>
</template>

<script>
import {
  countByProductIdAndTransportType,
  createProduct,
  deleteProduct,
  exportProductExcel,
  getProduct,
  getProductPage,
  product_coupon_newProd,
  updateProduct
} from "@/api/ecw/product";
import {getProductAttrList} from "@/api/ecw/productAttr";
import {getProductTypeList} from "@/api/ecw/productType";
import {DICT_TYPE, getDictDatas} from '@/utils/dict';
import {AuditStatusEnum, CommonStatusEnum} from '@/utils/constants';
import {uploadFile} from "@/api/infra/file";
import ImageUpload from '@/components/ImageUpload'
import PackagingType from "@/views/ecw/channel/componrnts/packaging-type.vue";

export default {
  name: "product-dialog",
  components: {
    PackagingType,
    ImageUpload
  },
  data() {
    return {
      visible:false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      //特性列表
      attrList: [],
      //类型列表
      typeList: [],
      //材质列表
      materialList: [],
      //包装列表
      packagingList: [],
      //货柜位置
      locationList: [],

      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 产品列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        typeId: null,
        attrId: null,
        titleZh: null,
        titleEn: null,
        auditStatus: null,
        status: null,
      },
      // 表单参数
      form: {

      },
      // 表单校验
      rules: {
        typeId: [{ required: true, message: this.$t("商品类型不能为空"), trigger: "change" }],
        attrArray: [{ required: true, message: this.$t("商品特性不能为空"), trigger: "change" }],
        titleZh: [{ required: true, message: this.$t("中文标题不能为空"), trigger: "blur" }],
        titleEn: [{ required: true, message: this.$t("英文标题不能为空"), trigger: "blur" }],
        // materialType: [{ required: true, message: this.$t("商品材质不能为空"), trigger: "blur" }],
        // packaging: [{ required: true, message: this.$t("包装要求不能为空"), trigger: "blur" }],
        // containerLocation: [{ required: true, message: this.$t("默认货柜位置不能为空"), trigger: "blur" }],
        // square: [{ required: true, message: this.$t("订单方数上线不能为空"), trigger: "blur" }],
        // needBook: [{ required: true, message: this.$t("是否预约入仓不能为空"), trigger: "blur" }],
      },

      CommonStatusEnum: CommonStatusEnum,
      AuditStatusEnum: AuditStatusEnum,
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),
      auditStatusDictDatas: getDictDatas(DICT_TYPE.AUDIT_STATUS),
      materialList: getDictDatas(DICT_TYPE.ECW_PRODUCT_MATERIAL),
      packagingList: getDictDatas(DICT_TYPE.ECW_PACKAGING_TYPE),
      locationList: getDictDatas(DICT_TYPE.ECW_CONTAINER_LOCATION),
      preferentialList:[],
      exceptionProductId:0//新增商品异常传的id
    };
  },

  computed: {
    getTypeName() {
      return typeId => {
        for (let index in this.typeList) {
          let typeItem = this.typeList[index];
          if (typeItem.id == typeId) {
            return this.$l(typeItem, 'title');
          }
        }
      }
    },

    getAttrName() {
      return attrIds => {
        let productAttrArray = [];
        let attrArray = attrIds.split(',');
        for (let attrIndex in attrArray) {
          let attrId = attrArray[attrIndex];
          for (let index in this.attrList) {
            let attrItem = this.attrList[index];
            if (attrItem.id == attrId) {
              productAttrArray.push(this.$l(attrItem, 'attrName'));
            }
          }
        }
        return productAttrArray.join(',');
      }
    },
    firstImg(){
      return imgString => {
        if(!imgString || imgString == '') return imgString
        let imgs = imgString.split(',')
        return imgs.length ? imgs[0] : null
      }
    }
  },

  activated(){
    if(this.$route.query.typeId != this.queryParams.typeId){
      this.queryParams.typeId = +this.$route.query.typeId || null
    }
    //新增商品异常跳转商品修改
    if(this.$route.query.prodId){
      this.exceptionProductId = this.$route.query.prodId
      this.handleUpdate({id:this.$route.query.prodId})
    }
    this.getList()
  },
  created() {
    //新增商品异常跳转商品修改
    if(this.$route.query.prodId){
      this.exceptionProductId = this.$route.query.prodId
      this.handleUpdate({id:this.$route.query.prodId})
    }
    let typeId = this.$route.query.typeId;
    if (typeId) {
      this.queryParams.typeId = parseInt(typeId);
    }
    this.getAttrList();
    this.getTypeList();
    this.getList();

  },
  methods: {
    copyLine(row, bol){
      if(bol){
        countByProductIdAndTransportType({productId:row.id}).then(r =>{
          this.$emit( 'copyLine', {...row,priceLineCount:r.data}, bol)
        })
      }else {
        this.$emit( 'copyLine', row, bol)
      }
      console.log(bol,'bol')
    },
    /** 获取产品属性列表 */
    getAttrList() {
      getProductAttrList().then(response => {
        this.attrList = response.data;
      })
    },

    /** 获取产品类型列表 */
    getTypeList() {
      getProductTypeList().then(response => {
        this.typeList = response.data;
      })
    },

    /**跳转价格管理 */
    toPriceManager(row) {
      /* localStorage.setItem('product', JSON.stringify(row));
      localStorage.setItem('typeList', JSON.stringify(this.typeList)); */
      this.$router.push({
        name: 'ProductPrice',
        query: {
          product_id: row.id,
          product_type: row.typeId
        }
      })
    },

    handleStatusChange(row, statusType) {
      updateProduct(row).then(() => {
        this.$modal.msgSuccess(this.$t("修改成功"));
      }).catch(function () {
        if (statusType == 'status') {
          row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE : CommonStatusEnum.ENABLE;
        } else {
          row.auditStatus = row.auditStatus === AuditStatusEnum.PASS ? AuditStatusEnum.NOT_PASS : AuditStatusEnum.PASS;
        }

      });
    },

    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = { ...this.queryParams };
      params.filter=false;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      params.status = 0;
      getProductPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        typeId: undefined,
        attrArray: undefined,
        attrId: undefined,
        titleZh: undefined,
        titleEn: undefined,
        auditStatus: undefined,
        status: undefined,
        requirements: 0,
        needBook: 0,
        couponIds:[],
        airWeightLimit:undefined,
        priceStepClearanceList:[],
        channelPriceStepClearanceList:[],
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t("添加商品");
      product_coupon_newProd().then(r => {
        this.preferentialList = r.data
        this.form.couponIds = this.preferentialList.filter(i => i.isDefault).map(i => i.couponId)
      })
      if (this.queryParams.typeId) {
        this.form.typeId = this.queryParams.typeId;
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      // this.reset();
      console.log(row);
      const id = row.id;
      getProduct(id).then(response => {
        this.form = {...response.data,couponIds:[]};
        this.form.channelPriceStepClearanceList = this.form.priceStepClearanceList;
        let attrArray = this.form.attrId?this.form.attrId.split(','):[];
        for (let index in attrArray) {
          let value = attrArray[index];
          attrArray[index] = parseInt(value);
        }
        this.$nextTick(() =>{
          this.$set(this.form, 'attrArray', attrArray)
        })
        this.open = true;
        this.title = this.$t("修改商品");
        product_coupon_newProd({prodId:id}).then(r => {
          this.preferentialList = r.data
          this.form.couponIds = this.preferentialList.filter(i => i.isDefault).map(i => i.couponId)
          // this.reset()
        })
      });
    },

    /** 提交按钮 */
    submitForm() {
      console.log(this.form);
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        this.form.priceStepClearanceList = this.form.channelPriceStepClearanceList;
        //商品特性转字符串
        this.form.attrId = this.form.attrArray.join(',');
        // 修改的提交
        if (this.form.id != null) {
          this.form.priceStepClearanceList.forEach(i =>{
            i.productId = this.form.id
          })
          if(this.exceptionProductId){
            this.form.productId = this.exceptionProductId
            this.form.status = 0
          }else {
            this.form.productId = this.form.id
          }
          updateProduct(this.form).then(response => {
            this.$modal.msgSuccess(this.$t("修改成功"));
            this.open = false;
            if(this.exceptionProductId){
              this.exceptionProductId = null
              this.$router.replace({ path: '/product/product-list'})
            }
            this.getList();
          });
          return;
        }
        // 添加的提交
        createProduct(this.form).then(response => {
          this.$modal.msgSuccess(this.$t("新增成功"));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除商品编号为{id}的数据项?', {id})).then(function () {
        return deleteProduct(id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t("删除成功"));
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = { ...this.queryParams };
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出所有商品数据项?')).then(() => {
        this.exportLoading = true;
        return exportProductExcel(params);
      }).then(response => {
        this.$download.excel(response, '商品.xlsx');
        this.exportLoading = false;
      }).catch(() => { });
    },

    // 覆盖默认的上传行为
    requestUpload() {
    },
    // 上传预处理
    beforeUpload(file) {
      if (file.type.indexOf("image/") == -1) {
        this.$modal.msgError(this.$t("文件格式错误，请上传图片类型,如：JPG，PNG后缀的文件。"));
      } else {
        //上传
        let formData = new FormData();
        formData.append("file", file);
        formData.append("path", this.uuid());
        uploadFile(formData).then(response => {
          this.$set(this.form, 'imgs', response.data);
          // this.form.img = response.data;
        })
      }
    },

    uuid() {
      var s = [];
      var hexDigits = "0123456789abcdef";
      for (var i = 0; i < 36; i++) {
        s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
      }
      s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
      s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
      s[8] = s[13] = s[18] = s[23] = "-";

      var uuid = s.join("");
      return uuid;
    },
    // 批量设置商品属性
    handleEdit() {
      this.$router.push({
        path: "product-attr/edit",
        query: {
          ids: this.ids
        }
      });
    },
    selectMoveAbout(val){
      if(!val.mandatory){
        let index = this.form.couponIds.findIndex(i => val.couponId == i)
        if(index >= 0){
          this.$confirm(this.$t(`您确定要将商品从优惠活动${this.$l(val,'title')}中移出吗？`), this.$t('提示'), {
            confirmButtonText: this.$t('确定'),
            cancelButtonText:this.$t('取消') ,
            type: 'warning'
          }).then(() => {
            this.form.couponIds.splice(index,1)
            this.$forceUpdate()
          }).catch(() => {

          });
        }else {
          this.$confirm(this.$t(`您确定要将商品加入到优惠活动${this.$l(val,'title')}中吗？`), this.$t('提示'), {
            confirmButtonText: this.$t('确定'),
            cancelButtonText:this.$t('取消') ,
            type: 'warning'
          }).then(() => {
            this.form.couponIds.push(val.couponId)
            this.$forceUpdate()
          }).catch(() => {

          });
        }
      }
    }
  },
};
</script>

<style lang="scss" scoped>

</style>
